// Mod: Time for Xin Calendar 2 (In-Page/Popup-Window)
// Copyright 2005  Xin Yang    All Rights Reserved.

// Last Modified: 05-May-2006

// Internal functions
var xcFields=new Array();
function xcAddField(targetField) {
  xcFields[xcFields.length]=targetField;
}

function xcGetHMSFromDate(date) {
  var hrIdx=xcDateFormat.search(/hr/i);
  var miIdx=xcDateFormat.search(/mi/i);
  var ssIdx=xcDateFormat.search(/ss/i);
  var amIdx=xcDateFormat.search(/am/i);

  var hr=hrIdx<0?"":date.substring(hrIdx,hrIdx+2);
  var mi=miIdx<0?"":date.substring(miIdx,miIdx+2);
  var ss=ssIdx<0?"":date.substring(ssIdx,ssIdx+2);
  var am=amIdx<0?"":date.substring(amIdx,amIdx+2);

  return new Array(hr,mi,ss,am);
}

function xcSetHMSToDate(date,hr,mi,ss,am) {
  var hrIdx=xcDateFormat.search(/hr/i);
  var miIdx=xcDateFormat.search(/mi/i);
  var ssIdx=xcDateFormat.search(/ss/i);
  var amIdx=xcDateFormat.search(/am/i);

  if (hrIdx>=0) {
    date=date.substring(0,hrIdx)+hr+date.substring(hrIdx+2);
  }
  if (miIdx>=0) {
    date=date.substring(0,miIdx)+mi+date.substring(miIdx+2);
  }
  if (ssIdx>=0) {
    date=date.substring(0,ssIdx)+ss+date.substring(ssIdx+2);
  }
  if (amIdx>=0) {
    date=date.substring(0,amIdx)+am+date.substring(amIdx+2);
  }

  return date;
}

function xcShowTime(targetField, refField, defaultDate, lastDate, calIdx) {
  if (typeof(targetField.iden)=="undefined") {
    targetField.iden=String((new Date()).getTime());
    xcAddField(targetField);
  }
  var fieldIdentity="xc_"+targetField.iden;

  var hmsaValues=["","","",""], hmsaChars=["hr","mi","ss","am"], hmsaPools=[xcHours,xcMinutes,xcSeconds,xcAMPM], hmsaLists="";
  var curCal=xcFindCal(calIdx), date=curCal.get()||curCal.defaultDate;
  if (checkDate(date)==0) {
    hmsaValues=xcGetHMSFromDate(date);
  }

  hmsaLists=xcTableOpen0+xcTROpen;
  for (var i=0; i<hmsaChars.length; i++) {
    if (xcDateFormat.toLowerCase().indexOf(hmsaChars[i])!=-1) {
      hmsaLists+="<TD><SELECT ID='"+fieldIdentity+"_"+hmsaChars[i]+"' CLASS='"+xcCSSTimeList+"' ONCHANGE='xcScrollTime("+calIdx+")'>";
      for (var j=0; j<hmsaPools[i].length; j++) {
        hmsaLists+="<OPTION";
        if (hmsaPools[i][j]==hmsaValues[i]) {
          hmsaLists+=" SELECTED";
        }
        hmsaLists+=">"+hmsaPools[i][j]+"</OPTION>";
      }
      hmsaLists+="</SELECT></TD>";
    }
  }
  hmsaLists+=xcTRClose+xcTableClose;

  return hmsaLists;
}

function xcScrollTime(idx) {
  var curCal=xcFindCal(idx);

  curCal.beforeGet();
  var calDate=curCal.beforeUpdate(curCal.afterGet(curCal.get()||curCal.defaultDate||getCurrentDate()));
  curCal.update(calDate);
  curCal.afterUpdate(calDate);
  curCal.lastDate=calDate;
}

function xcAddTimeLists() {
  xcCSSFootOther[xcCSSFootOther.length]=xcCSSTimeBlock;
  xcFootButtons[xcFootButtons.length]=xcShowTime;
  xcFootButtonSwitch[xcFootButtonSwitch.length]=xcTimeBlockOrder;
  xcFootButtonLinks[xcFootButtonLinks.length]=null;
};
xcAddTimeLists();

// Overloaded functions
function xcBeforeUpdate(date) {
  var hrValue=miValue=ssValue=amValue="";
  var doc=xcCore==2?this.windowHandler.document:document;

  if (/hr/i.test(xcDateFormat)) {
    var hrList=doc.getElementById("xc_"+this.targetField.iden+"_hr");
    hrValue=hrList.options[hrList.selectedIndex].text;
  }
  if (/mi/i.test(xcDateFormat)) {
    var miList=doc.getElementById("xc_"+this.targetField.iden+"_mi");
    miValue=miList.options[miList.selectedIndex].text;
  }
  if (/ss/i.test(xcDateFormat)) {
    var ssList=doc.getElementById("xc_"+this.targetField.iden+"_ss");
    ssValue=ssList.options[ssList.selectedIndex].text;
  }
  if (/am/i.test(xcDateFormat)) {
    var amList=doc.getElementById("xc_"+this.targetField.iden+"_am");
    amValue=amList.options[amList.selectedIndex].text;
  }

  return beforeSetDateValue(this.refField,this.targetField,xcSetHMSToDate(date,hrValue,miValue,ssValue,amValue));
}

function compareDates(date1,date2) {
  var calRE=xcGetDateFormatRE();
  var d1=getDateNumbers(calRE.test(date1)?date1:getCurrentDate()).join("");
  var d2=getDateNumbers(calRE.test(date2)?date2:getCurrentDate()).join("");

  var t1=xcGetHMSFromDate(date1);
  var t2=xcGetHMSFromDate(date2);
  d1+=t1[0]==""?"00":t1[3]==xcAMPM[1]?xcGetDD(parseInt(t1[0],10)+12):t1[0];
  d2+=t2[0]==""?"00":t2[3]==xcAMPM[1]?xcGetDD(parseInt(t2[0],10)+12):t2[0];

  d1+=t1[1]==""?"00":t1[1];
  d2+=t2[1]==""?"00":t2[1];

  d1+=t1[2]==""?"00":t1[2];
  d2+=t2[2]==""?"00":t2[2];

  return (d1==d2?0:d1>d2?1:-1);
}
